STMonadTrans-0.4.8.1: A monad transformer version of the ST monad

Copyright | Josef Svenningsson 2008-2010 (c) The University of Glasgow 1994-2000
License | BSD
Maintainer | josef.svenningsson@gmail.com, Andreas Abel
Stability | stable
Portability | non-portable (GHC Extensions)
Safe Haskell | None
Language | Haskell2010

Control.Monad.ST.Trans.Internal

Description

This module provides the implementation of the `STT` type for those occasions where it is needed in order to implement new liftings through operations in other monads.

Warning! This monad transformer should not be used with monads that can contain multiple answers, like the list monad. The reason is that the will be duplicated across the different answers and this cause Bad Things to happen (such as loss of referential transparency). Safe monads include the monads State, Reader, Writer, Maybe and combinations of their corresponding monad transformers.

Synopsis

- newtype STT s (m :: Type -> Type) a = STT (State# s -> m (STTRet s a))
- unSTT :: STT s m a -> State# s -> m (STTRet s a)
- data STTRet s a = STTRet (State# s) a
- liftST :: forall (m :: Type -> Type) s a. Applicative m => ST s a -> STT s m a
- liftSTT :: STT s m a -> State# s -> m (STTRet s a)

# Documentation

newtype STT s (m :: Type -> Type) a Source #

`STT` is the monad transformer providing polymorphic updateable references

Constructors

STT (State# s -> m (STTRet s a)) |

#### Instances

Instances details

(MonadError e m, Functor m) => MonadError e (STT s m) Source # |
Instance details Defined in Control.Monad.ST.Trans.Internal Methods throwError :: e -> STT s m a Source # catchError :: STT s m a -> (e -> STT s m a) -> STT s m a Source #
(MonadReader r m, Functor m) => MonadReader r (STT s m) Source # |
Instance details Defined in Control.Monad.ST.Trans.Internal Methods ask :: STT s m r Source # local :: (r -> r) -> STT s m a -> STT s m a Source # reader :: (r -> a) -> STT s m a Source #
(MonadState s m, Functor m) => MonadState s (STT s1 m) Source # |
Instance details Defined in Control.Monad.ST.Trans.Internal Methods get :: STT s1 m s Source # put :: s -> STT s1 m () Source # state :: (s -> (a, s)) -> STT s1 m a Source #
(MonadWriter w m, Functor m) => MonadWriter w (STT s m) Source # |
Instance details Defined in Control.Monad.ST.Trans.Internal Methods writer :: (a, w) -> STT s m a Source # tell :: w -> STT s m () Source # listen :: STT s m a -> STT s m (a, w) Source # pass :: STT s m (a, w -> w) -> STT s m a Source #
MonadTrans (STT s) Source # |
Instance details Defined in Control.Monad.ST.Trans.Internal Methods lift :: Monad m => m a -> STT s m a Source #
(Applicative m, Monad m) => MArray (STUArray s) Int16 (STT s m) Source # |

Instance details

Defined in Control.Monad.ST.Trans.Internal

Methods

getBounds :: Ix i => STUArray s i Int16 -> STT s m (i, i) Source #

getNumElements :: Ix i => STUArray s i Int16 -> STT s m Int Source #

newArray :: Ix i => (i, i) -> Int16 -> STT s m (STUArray s i Int16) Source #

newArray_ :: Ix i => (i, i) -> STT s m (STUArray s i Int16) Source #

unsafeNewArray_ :: Ix i => (i, i) -> STT s m (STUArray s i Int16) Source #

unsafeRead :: Ix i => STUArray s i Int16 -> Int -> STT s m Int16 Source #

unsafeWrite :: Ix i => STUArray s i Int16 -> Int -> Int16 -> STT s m () Source #

(Applicative m, Monad m) => MArray (STUArray s) Int32 (STT s m) Source # |

Instance details

Defined in Control.Monad.ST.Trans.Internal

Methods

getBounds :: Ix i => STUArray s i Int32 -> STT s m (i, i) Source #

getNumElements :: Ix i => STUArray s i Int32 -> STT s m Int Source #

newArray :: Ix i => (i, i) -> Int32 -> STT s m (STUArray s i Int32) Source #

newArray_ :: Ix i => (i, i) -> STT s m (STUArray s i Int32) Source #

unsafeNewArray_ :: Ix i => (i, i) -> STT s m (STUArray s i Int32) Source #

unsafeRead :: Ix i => STUArray s i Int32 -> Int -> STT s m Int32 Source #

unsafeWrite :: Ix i => STUArray s i Int32 -> Int -> Int32 -> STT s m () Source #

(Applicative m, Monad m) => MArray (STUArray s) Int64 (STT s m) Source # |

Instance details

Defined in Control.Monad.ST.Trans.Internal

Methods

getBounds :: Ix i => STUArray s i Int64 -> STT s m (i, i) Source #

getNumElements :: Ix i => STUArray s i Int64 -> STT s m Int Source #

newArray :: Ix i => (i, i) -> Int64 -> STT s m (STUArray s i Int64) Source #

newArray_ :: Ix i => (i, i) -> STT s m (STUArray s i Int64) Source #

unsafeNewArray_ :: Ix i => (i, i) -> STT s m (STUArray s i Int64) Source #

unsafeRead :: Ix i => STUArray s i Int64 -> Int -> STT s m Int64 Source #

unsafeWrite :: Ix i => STUArray s i Int64 -> Int -> Int64 -> STT s m () Source #

(Applicative m, Monad m) => MArray (STUArray s) Int8 (STT s m) Source # |

Instance details

Defined in Control.Monad.ST.Trans.Internal

Methods

getBounds :: Ix i => STUArray s i Int8 -> STT s m (i, i) Source #

getNumElements :: Ix i => STUArray s i Int8 -> STT s m Int Source #

newArray :: Ix i => (i, i) -> Int8 -> STT s m (STUArray s i Int8) Source #

newArray_ :: Ix i => (i, i) -> STT s m (STUArray s i Int8) Source #

unsafeNewArray_ :: Ix i => (i, i) -> STT s m (STUArray s i Int8) Source #

unsafeRead :: Ix i => STUArray s i Int8 -> Int -> STT s m Int8 Source #

unsafeWrite :: Ix i => STUArray s i Int8 -> Int -> Int8 -> STT s m () Source #

(Applicative m, Monad m) => MArray (STUArray s) Word16 (STT s m) Source # |

Instance details

Defined in Control.Monad.ST.Trans.Internal

Methods

getBounds :: Ix i => STUArray s i Word16 -> STT s m (i, i) Source #

getNumElements :: Ix i => STUArray s i Word16 -> STT s m Int Source #

newArray :: Ix i => (i, i) -> Word16 -> STT s m (STUArray s i Word16) Source #

newArray_ :: Ix i => (i, i) -> STT s m (STUArray s i Word16) Source #

unsafeNewArray_ :: Ix i => (i, i) -> STT s m (STUArray s i Word16) Source #

unsafeRead :: Ix i => STUArray s i Word16 -> Int -> STT s m Word16 Source #

unsafeWrite :: Ix i => STUArray s i Word16 -> Int -> Word16 -> STT s m () Source #

(Applicative m, Monad m) => MArray (STUArray s) Word32 (STT s m) Source # |

Instance details

Defined in Control.Monad.ST.Trans.Internal

Methods

getBounds :: Ix i => STUArray s i Word32 -> STT s m (i, i) Source #

getNumElements :: Ix i => STUArray s i Word32 -> STT s m Int Source #

newArray :: Ix i => (i, i) -> Word32 -> STT s m (STUArray s i Word32) Source #

newArray_ :: Ix i => (i, i) -> STT s m (STUArray s i Word32) Source #

unsafeNewArray_ :: Ix i => (i, i) -> STT s m (STUArray s i Word32) Source #

unsafeRead :: Ix i => STUArray s i Word32 -> Int -> STT s m Word32 Source #

unsafeWrite :: Ix i => STUArray s i Word32 -> Int -> Word32 -> STT s m () Source #

(Applicative m, Monad m) => MArray (STUArray s) Word64 (STT s m) Source # |

Instance details

Defined in Control.Monad.ST.Trans.Internal

Methods

getBounds :: Ix i => STUArray s i Word64 -> STT s m (i, i) Source #

getNumElements :: Ix i => STUArray s i Word64 -> STT s m Int Source #

newArray :: Ix i => (i, i) -> Word64 -> STT s m (STUArray s i Word64) Source #

newArray_ :: Ix i => (i, i) -> STT s m (STUArray s i Word64) Source #

unsafeNewArray_ :: Ix i => (i, i) -> STT s m (STUArray s i Word64) Source #

unsafeRead :: Ix i => STUArray s i Word64 -> Int -> STT s m Word64 Source #

unsafeWrite :: Ix i => STUArray s i Word64 -> Int -> Word64 -> STT s m () Source #

(Applicative m, Monad m) => MArray (STUArray s) Word8 (STT s m) Source # |

Instance details

Defined in Control.Monad.ST.Trans.Internal

Methods

getBounds :: Ix i => STUArray s i Word8 -> STT s m (i, i) Source #

getNumElements :: Ix i => STUArray s i Word8 -> STT s m Int Source #

newArray :: Ix i => (i, i) -> Word8 -> STT s m (STUArray s i Word8) Source #

newArray_ :: Ix i => (i, i) -> STT s m (STUArray s i Word8) Source #

unsafeNewArray_ :: Ix i => (i, i) -> STT s m (STUArray s i Word8) Source #

unsafeRead :: Ix i => STUArray s i Word8 -> Int -> STT s m Word8 Source #

unsafeWrite :: Ix i => STUArray s i Word8 -> Int -> Word8 -> STT s m () Source #

(Applicative m, Monad m) => MArray (STUArray s) Bool (STT s m) Source # |

Instance details

Defined in Control.Monad.ST.Trans.Internal

Methods

getBounds :: Ix i => STUArray s i Bool -> STT s m (i, i) Source #

getNumElements :: Ix i => STUArray s i Bool -> STT s m Int Source #

newArray :: Ix i => (i, i) -> Bool -> STT s m (STUArray s i Bool) Source #

newArray_ :: Ix i => (i, i) -> STT s m (STUArray s i Bool) Source #

unsafeNewArray_ :: Ix i => (i, i) -> STT s m (STUArray s i Bool) Source #

unsafeRead :: Ix i => STUArray s i Bool -> Int -> STT s m Bool Source #

unsafeWrite :: Ix i => STUArray s i Bool -> Int -> Bool -> STT s m () Source #

(Applicative m, Monad m) => MArray (STUArray s) Char (STT s m) Source # |

Instance details

Defined in Control.Monad.ST.Trans.Internal

Methods

getBounds :: Ix i => STUArray s i Char -> STT s m (i, i) Source #

getNumElements :: Ix i => STUArray s i Char -> STT s m Int Source #

newArray :: Ix i => (i, i) -> Char -> STT s m (STUArray s i Char) Source #

newArray_ :: Ix i => (i, i) -> STT s m (STUArray s i Char) Source #

unsafeNewArray_ :: Ix i => (i, i) -> STT s m (STUArray s i Char) Source #

unsafeRead :: Ix i => STUArray s i Char -> Int -> STT s m Char Source #

unsafeWrite :: Ix i => STUArray s i Char -> Int -> Char -> STT s m () Source #

(Applicative m, Monad m) => MArray (STUArray s) Double (STT s m) Source # |

Instance details

Defined in Control.Monad.ST.Trans.Internal

Methods

getBounds :: Ix i => STUArray s i Double -> STT s m (i, i) Source #

getNumElements :: Ix i => STUArray s i Double -> STT s m Int Source #

newArray :: Ix i => (i, i) -> Double -> STT s m (STUArray s i Double) Source #

newArray_ :: Ix i => (i, i) -> STT s m (STUArray s i Double) Source #

unsafeNewArray_ :: Ix i => (i, i) -> STT s m (STUArray s i Double) Source #

unsafeRead :: Ix i => STUArray s i Double -> Int -> STT s m Double Source #

unsafeWrite :: Ix i => STUArray s i Double -> Int -> Double -> STT s m () Source #

(Applicative m, Monad m) => MArray (STUArray s) Float (STT s m) Source # |

Instance details

Defined in Control.Monad.ST.Trans.Internal

Methods

getBounds :: Ix i => STUArray s i Float -> STT s m (i, i) Source #

getNumElements :: Ix i => STUArray s i Float -> STT s m Int Source #

newArray :: Ix i => (i, i) -> Float -> STT s m (STUArray s i Float) Source #

newArray_ :: Ix i => (i, i) -> STT s m (STUArray s i Float) Source #

unsafeNewArray_ :: Ix i => (i, i) -> STT s m (STUArray s i Float) Source #

unsafeRead :: Ix i => STUArray s i Float -> Int -> STT s m Float Source #

unsafeWrite :: Ix i => STUArray s i Float -> Int -> Float -> STT s m () Source #

(Applicative m, Monad m) => MArray (STUArray s) Int (STT s m) Source # |

Instance details

Defined in Control.Monad.ST.Trans.Internal

Methods

getBounds :: Ix i => STUArray s i Int -> STT s m (i, i) Source #

getNumElements :: Ix i => STUArray s i Int -> STT s m Int Source #

newArray :: Ix i => (i, i) -> Int -> STT s m (STUArray s i Int) Source #

newArray_ :: Ix i => (i, i) -> STT s m (STUArray s i Int) Source #

unsafeNewArray_ :: Ix i => (i, i) -> STT s m (STUArray s i Int) Source #

unsafeRead :: Ix i => STUArray s i Int -> Int -> STT s m Int Source #

unsafeWrite :: Ix i => STUArray s i Int -> Int -> Int -> STT s m () Source #

(Applicative m, Monad m) => MArray (STUArray s) Word (STT s m) Source # |

Instance details

Defined in Control.Monad.ST.Trans.Internal

Methods

getBounds :: Ix i => STUArray s i Word -> STT s m (i, i) Source #

getNumElements :: Ix i => STUArray s i Word -> STT s m Int Source #

newArray :: Ix i => (i, i) -> Word -> STT s m (STUArray s i Word) Source #

newArray_ :: Ix i => (i, i) -> STT s m (STUArray s i Word) Source #

unsafeNewArray_ :: Ix i => (i, i) -> STT s m (STUArray s i Word) Source #

unsafeRead :: Ix i => STUArray s i Word -> Int -> STT s m Word Source #

unsafeWrite :: Ix i => STUArray s i Word -> Int -> Word -> STT s m () Source #

(Applicative m, Monad m) => MArray (STArray s) e (STT s m) Source # |

Instance details

Defined in Control.Monad.ST.Trans.Internal

Methods

getBounds :: Ix i => STArray s i e -> STT s m (i, i) Source #

getNumElements :: Ix i => STArray s i e -> STT s m Int Source #

newArray :: Ix i => (i, i) -> e -> STT s m (STArray s i e) Source #

newArray_ :: Ix i => (i, i) -> STT s m (STArray s i e) Source #

unsafeNewArray_ :: Ix i => (i, i) -> STT s m (STArray s i e) Source #

unsafeRead :: Ix i => STArray s i e -> Int -> STT s m e Source #

unsafeWrite :: Ix i => STArray s i e -> Int -> e -> STT s m () Source #

(Applicative m, Monad m) => MArray (STUArray s) (FunPtr a) (STT s m) Source # |

Instance details

Defined in Control.Monad.ST.Trans.Internal

Methods

getBounds :: Ix i => STUArray s i (FunPtr a) -> STT s m (i, i) Source #

getNumElements :: Ix i => STUArray s i (FunPtr a) -> STT s m Int Source #

newArray :: Ix i => (i, i) -> FunPtr a -> STT s m (STUArray s i (FunPtr a)) Source #

newArray_ :: Ix i => (i, i) -> STT s m (STUArray s i (FunPtr a)) Source #

unsafeNewArray_ :: Ix i => (i, i) -> STT s m (STUArray s i (FunPtr a)) Source #

unsafeRead :: Ix i => STUArray s i (FunPtr a) -> Int -> STT s m (FunPtr a) Source #

unsafeWrite :: Ix i => STUArray s i (FunPtr a) -> Int -> FunPtr a -> STT s m () Source #

(Applicative m, Monad m) => MArray (STUArray s) (Ptr a) (STT s m) Source # |

Instance details

Defined in Control.Monad.ST.Trans.Internal

Methods

getBounds :: Ix i => STUArray s i (Ptr a) -> STT s m (i, i) Source #

getNumElements :: Ix i => STUArray s i (Ptr a) -> STT s m Int Source #

newArray :: Ix i => (i, i) -> Ptr a -> STT s m (STUArray s i (Ptr a)) Source #

newArray_ :: Ix i => (i, i) -> STT s m (STUArray s i (Ptr a)) Source #

unsafeNewArray_ :: Ix i => (i, i) -> STT s m (STUArray s i (Ptr a)) Source #

unsafeRead :: Ix i => STUArray s i (Ptr a) -> Int -> STT s m (Ptr a) Source #

unsafeWrite :: Ix i => STUArray s i (Ptr a) -> Int -> Ptr a -> STT s m () Source #

(Applicative m, Monad m) => MArray (STUArray s) (StablePtr a) (STT s m) Source # |

Instance details

Defined in Control.Monad.ST.Trans.Internal

Methods

getBounds :: Ix i => STUArray s i (StablePtr a) -> STT s m (i, i) Source #

getNumElements :: Ix i => STUArray s i (StablePtr a) -> STT s m Int Source #

newArray :: Ix i => (i, i) -> StablePtr a -> STT s m (STUArray s i (StablePtr a)) Source #

newArray_ :: Ix i => (i, i) -> STT s m (STUArray s i (StablePtr a)) Source #

unsafeNewArray_ :: Ix i => (i, i) -> STT s m (STUArray s i (StablePtr a)) Source #

unsafeRead :: Ix i => STUArray s i (StablePtr a) -> Int -> STT s m (StablePtr a) Source #

unsafeWrite :: Ix i => STUArray s i (StablePtr a) -> Int -> StablePtr a -> STT s m () Source #

(MonadIO m, Functor m) => MonadIO (STT s m) Source # |
Instance details Defined in Control.Monad.ST.Trans.Internal Methods liftIO :: IO a -> STT s m a Source #
(Monad m, Alternative m) => Alternative (STT s m) Source # |
Instance details Defined in Control.Monad.ST.Trans.Internal Methods empty :: STT s m a Source # (<|>) :: STT s m a -> STT s m a -> STT s m a Source # some :: STT s m a -> STT s m [a] Source # many :: STT s m a -> STT s m [a] Source #
(Monad m, Functor m) => Applicative (STT s m) Source # |
Instance details Defined in Control.Monad.ST.Trans.Internal Methods pure :: a -> STT s m a Source # (<*>) :: STT s m (a -> b) -> STT s m a -> STT s m b Source # liftA2 :: (a -> b -> c) -> STT s m a -> STT s m b -> STT s m c Source # (*>) :: STT s m a -> STT s m b -> STT s m b Source # (<*) :: STT s m a -> STT s m b -> STT s m a Source #
Functor m => Functor (STT s m) Source # |
Instance details Defined in Control.Monad.ST.Trans.Internal Methods fmap :: (a -> b) -> STT s m a -> STT s m b Source # (<$) :: a -> STT s m b -> STT s m a Source #
(Monad m, Functor m) => Monad (STT s m) Source # |
Instance details Defined in Control.Monad.ST.Trans.Internal Methods (>>=) :: STT s m a -> (a -> STT s m b) -> STT s m b Source # (>>) :: STT s m a -> STT s m b -> STT s m b Source # return :: a -> STT s m a Source #
(MonadFail m, Functor m) => MonadFail (STT s m) Source # |
Instance details Defined in Control.Monad.ST.Trans.Internal Methods fail :: String -> STT s m a Source #
(MonadFix m, Functor m) => MonadFix (STT s m) Source # |
Instance details Defined in Control.Monad.ST.Trans.Internal Methods mfix :: (a -> STT s m a) -> STT s m a Source #

unSTT :: STT s m a -> State# s -> m (STTRet s a) Source #

data STTRet s a Source #

`STTRet` is needed to encapsulate the unboxed state token that GHC passes around. This type is essentially a pair, but an ordinary pair is not not allowed to contain unboxed types.

Constructors

STTRet (State# s) a |

#### Instances

Instances details

Functor (STTRet s) Source # |
Instance details Defined in Control.Monad.ST.Trans.Internal Methods fmap :: (a -> b) -> STTRet s a -> STTRet s b Source # (<$) :: a -> STTRet s b -> STTRet s a Source #

liftST :: forall (m :: Type -> Type) s a. Applicative m => ST s a -> STT s m a Source #

Lifting the `ST` monad into `STT`. The library uses this function extensively to be able to reuse functions from `ST`.

liftSTT :: STT s m a -> State# s -> m (STTRet s a) Source #